/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.FormaPagoDAO;
import com.rjconsultores.ventaboletos.entidad.FormaPago;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Administrador
 */
@Repository("formaPagoDAO")
public class FormaPagoHibernateDAO extends GenericHibernateDAO<FormaPago, Short>
        implements FormaPagoDAO {

    @Autowired
    public FormaPagoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<FormaPago> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.addOrder(Order.asc("descpago"));

        return c.list();
    }

    public List<FormaPago> buscarPorDescricao(String descpago) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.add(Restrictions.eq("descpago", descpago));

        return c.list();
    }

    public List<FormaPago> buscarTodosExceto(Integer... idFormaPago) {
        Criteria c = this.makeCriteria();
        for (Integer id : idFormaPago) {
            c.add(Restrictions.ne("formapagoId", id.shortValue()));
        }
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.addOrder(Order.asc("descpago"));
        return c.list();

    }
    
    public List<FormaPago> buscarNotIn(Short... idsFormaPago) {
        Criteria c = this.makeCriteria();
        for (Short id : idsFormaPago) {
            c.add(Restrictions.ne("formapagoId", id));
        }
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.addOrder(Order.asc("descpago"));
        return c.list();

    }

	public List<FormaPago> buscarIn(Short... idFormaPago) {
		Criteria c = this.makeCriteria();
		c.add(Restrictions.in("formapagoId", idFormaPago));
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.addOrder(Order.asc("descpago"));
		return c.list();

	}
}
